﻿using SharpMap.Data;
using SharpMap.Geometries;
using System;
using System.Collections.Generic;
using System.Data.Spatial;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DevartSharpMapDemo {

  public class LabelTable : FeatureDataTable {

    public LabelTable() {

      Columns.Add(LabelColumnName, typeof(string));
    }    

    public void AddRow(Geometry geometry, string label) {

      FeatureDataRow row = NewRow();
      row.Geometry = geometry;
      row[LabelColumnName] = label;
      AddRow(row);
    }

    public void AddRow(DbGeometry dbGeometry, string label) {

      AddRow((Geometry)dbGeometry.ProviderValue, label);
    }

    public void AddRow(DbGeography dbGeography, string label) {

      AddRow((Geometry)dbGeography.ProviderValue, label);
    }

    public static string LabelColumnName = "LABEL";

  }

}
