﻿using Devart.Data.Oracle.Entity.Configuration;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using System.Data.Spatial;
using System.Text;

namespace DevartSharpMapDemo {

  public class Model : DbContext {

    public Model() {
    }

    static Model() {

      Database.SetInitializer<Model>(null);

      var config = OracleEntityProviderConfig.Instance;

      config.SpatialOptions.SpatialServiceType = SpatialServiceType.SharpMap;
      config.SpatialOptions.GeographyDistanceUnit = DistanceMeasurementUnit.Kilometer;
      config.SpatialOptions.GeographyAreaUnit = AreaMeasurementUnit.SquareKilometer;
      
      config.CodeFirstOptions.UseNonLobStrings = true;
      config.CodeFirstOptions.UseNonUnicodeStrings = true;

      config.Workarounds.DisableQuoting = true;
    }

    public DbSet<Region> Regions { get; set; }

    public DbSet<City> Cities { get; set; }

  }

  public class Region {

    [DatabaseGenerated(DatabaseGeneratedOption.None)]
    public int Id { get; set; }

    public DbGeography Geometry { get; set; }

  }

  public class City {

    [DatabaseGenerated(DatabaseGeneratedOption.None)]
    public int Id { get; set; }

    public DbGeography Geometry { get; set; }

    public string Name { get; set; }

  }

}
