﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;

namespace DevartSharpMapDemo {

  public partial class frmDemo : Form {
    
    private Devart.Data.Oracle.OracleMonitor monitor;
    private OracleToSharpMapLoader loader;

    public frmDemo() {

      InitializeComponent();

      monitor = new Devart.Data.Oracle.OracleMonitor() { IsActive = true };
      loader = new OracleToSharpMapLoader();
    }

    private void frmMain_Load(object sender, EventArgs e) {

      this.Cursor = Cursors.WaitCursor;
      try {
        List<string> cityNames;
        SetImage(loader.LoadFranceMap(out cityNames));

        var cities = cityNames.OfType<object>().ToArray();
        cbFirstCity.Items.AddRange(cities);
        cbSecondCity.Items.AddRange(cities);
        cbSecondCity.Items.Add("all cities");
        cbFirstCity.SelectedItem = cbFirstCity.Items[0];
        cbSecondCity.SelectedItem = cbSecondCity.Items[10];
      }
      finally {
        this.Cursor = Cursors.Default;
      }
    }

    private void btnFindDistance_Click(object sender, EventArgs e) {

      this.Cursor = Cursors.WaitCursor;
      try {
        string firstCityName = (string)cbFirstCity.SelectedItem;
        string secondCityName = (string)cbSecondCity.SelectedItem;

        SetImage(loader.FindDistance(firstCityName, secondCityName));
      }
      finally {
        this.Cursor = Cursors.Default;
      }
    }

    private void btnFindGreatestRegions_Click(object sender, EventArgs e) {

      this.Cursor = Cursors.WaitCursor;
      try {
        int count = (int)nudGreatestCount.Value;
        bool useDifferentColors = cbUseDifferentColors.Checked;
        bool showLabels = cbShowAreas.Checked;

        SetImage(loader.FindGreatestRegions(count, useDifferentColors, showLabels));
      }
      finally {
        this.Cursor = Cursors.Default;
      }
    }

    private void SetImage(Image image) {

      picBox.Image = image;
      picBox.Refresh();
    }

  }

}
